#!/usr/bin/env python3
# -*- coding:utf-8 -*-


import PyTango
from PyQt4.QtCore import *
from PyQt4.QtGui import *

devicelist = {}
devicelist['1'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/timing/rttrigger_sl.01')
devicelist['2'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/timing/rttrigger_sl.02')
devicelist['3'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/timing/rttrigger_sl.03')
devicelist['4'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/timing/rttrigger_sl.04')
devicelist['5'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/timing/rttrigger_sl.05')
devicelist['contollo'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/ec-sl-slpsr-01/rtevr/ff100000')
devicelist['frequenza'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/timing/bunchnumber_f')
selettore = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/laser/calendar_sl.01").activityNum

class MainWindow(QTabWidget):
    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        self.paginagenerale = QFrame()
        self.paginagenerale_1facileindicatore = QLineEdit()
        self.paginagenerale_1etichetta = QLabel('f/timing/rttrigger_sl.01')
        self.paginagenerale_1modalita = LineEditRO()
        self.paginagenerale_1on = QPushButton('START (random)')
        self.paginagenerale_1on.clicked.connect(self.accendi1_nobn)
        self.paginagenerale_1off = QPushButton('STOP')
        self.paginagenerale_1off.clicked.connect(self.spegni1)
        self.paginagenerale_1conf = QToolButton()
        self.paginagenerale_1conf.setArrowType(4)
        self.paginagenerale_1conf.clicked.connect(lambda: self.setCurrentIndex(1))
        self.paginagenerale_2facileindicatore = QLineEdit()
        self.paginagenerale_2etichetta = QLabel('f/timing/rttrigger_sl.02')
        self.paginagenerale_2modalita = LineEditRO()
        self.paginagenerale_2on = QPushButton('START (random)')
        self.paginagenerale_2on.clicked.connect(self.accendi2_nobn)
        self.paginagenerale_2off = QPushButton('STOP')
        self.paginagenerale_2off.clicked.connect(self.spegni2)
        self.paginagenerale_2conf = QToolButton()
        self.paginagenerale_2conf.setArrowType(4)
        self.paginagenerale_2conf.clicked.connect(lambda: self.setCurrentIndex(2))
        self.paginagenerale_3facileindicatore = QLineEdit()
        self.paginagenerale_3etichetta = QLabel('f/timing/rttrigger_sl.03')
        self.paginagenerale_3modalita = LineEditRO()
        self.paginagenerale_3on = QPushButton('START (random)')
        self.paginagenerale_3on.clicked.connect(self.accendi3_nobn)
        self.paginagenerale_3off = QPushButton('STOP')
        self.paginagenerale_3off.clicked.connect(self.spegni3)
        self.paginagenerale_3conf = QToolButton()
        self.paginagenerale_3conf.setArrowType(4)
        self.paginagenerale_3conf.clicked.connect(lambda: self.setCurrentIndex(3))
        self.paginagenerale_4facileindicatore = QLineEdit()
        self.paginagenerale_4etichetta = QLabel('f/timing/rttrigger_sl.04')
        self.paginagenerale_4modalita = LineEditRO()
        self.paginagenerale_4on = QPushButton('START (random)')
        self.paginagenerale_4on.clicked.connect(self.accendi4_nobn)
        self.paginagenerale_4off = QPushButton('STOP')
        self.paginagenerale_4off.clicked.connect(self.spegni4)
        self.paginagenerale_4conf = QToolButton()
        self.paginagenerale_4conf.setArrowType(4)
        self.paginagenerale_4conf.clicked.connect(lambda: self.setCurrentIndex(4))
        self.paginagenerale_5facileindicatore = QLineEdit()
        self.paginagenerale_5etichetta = QLabel('f/timing/rttrigger_sl.05')
        self.paginagenerale_5modalita = LineEditRO()
        self.paginagenerale_5on = QPushButton('START (random)')
        self.paginagenerale_5on.clicked.connect(self.accendi5_nobn)
        self.paginagenerale_5off = QPushButton('STOP')
        self.paginagenerale_5off.clicked.connect(self.spegni5)
        self.paginagenerale_5conf = QToolButton()
        self.paginagenerale_5conf.setArrowType(4)
        self.paginagenerale_5conf.clicked.connect(lambda: self.setCurrentIndex(5))
        self.LO_paginagenerale = QGridLayout()
        self.LO_paginagenerale.addWidget(self.paginagenerale_1facileindicatore, 10, 0, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_1etichetta, 10, 1, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_1modalita, 10, 2, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_1on, 10, 3, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_1off, 10, 4, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_1conf, 10, 5, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_2facileindicatore, 20, 0, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_2etichetta, 20, 1, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_2modalita, 20, 2, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_2on, 20, 3, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_2off, 20, 4, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_2conf, 20, 5, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_3facileindicatore, 30, 0, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_3etichetta, 30, 1, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_3modalita, 30, 2, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_3on, 30, 3, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_3off, 30, 4, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_3conf, 30, 5, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_4facileindicatore, 40, 0, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_4etichetta, 40, 1, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_4modalita, 40, 2, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_4on, 40, 3, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_4off, 40, 4, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_4conf, 40, 5, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_5facileindicatore, 50, 0, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_5etichetta, 50, 1, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_5modalita, 50, 2, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_5on, 50, 3, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_5off, 50, 4, 1, 1)
        self.LO_paginagenerale.addWidget(self.paginagenerale_5conf, 50, 5, 1, 1)
        self.paginagenerale.setLayout(self.LO_paginagenerale)
        #
        self.paginadeci1 = QFrame()
        self.paginadeci1_info1 = QLabel('This decive acts on the trigger signal for both SEED and SLU')
        self.paginadeci1_info2 = QLabel('')
        self.paginadeci1_campo_StateL = QLabel('State(misleading): ')
        self.paginadeci1_campo_State = LineEditRO()
        self.paginadeci1_campo_StatusL = QLabel('Status: ')
        self.paginadeci1_campo_Status = LineEditRO()
        self.paginadeci1_campo_mode = QLabel('MODE:')
        self.paginadeci1_campo_modeR = LineEditRO()
        self.paginadeci1_campo_DelayMode = QPushButton('DELAY')
        self.paginadeci1_campo_DelayMode.chiave = '1'
        self.paginadeci1_campo_DelayMode.clicked.connect(self.sceltadelay)
        self.paginadeci1_campo_StatusMode = QPushButton('STATUS')
        self.paginadeci1_campo_StatusMode.chiave = '1'
        self.paginadeci1_campo_StatusMode.clicked.connect(self.sceltastatus)
        self.paginadeci1_off = QPushButton('STOP')
        self.paginadeci1_off.clicked.connect(self.spegni3)
        self.paginadeci1_on = QPushButton('START (random)')
        self.paginadeci1_on.clicked.connect(self.accendi1_nobn)
        self.paginadeci1_partipari = QPushButton('START even')
        self.paginadeci1_partipari.clicked.connect(self.accendi1_even)
        self.paginadeci1_partidispari = QPushButton('START odd')
        self.paginadeci1_partidispari.clicked.connect(self.accendi1_odd)
        self.paginadeci1_campo_Sequence_L = QLabel('Sequence: ')
        self.paginadeci1_campo_Sequence_R = LineEditRO()
        self.paginadeci1_campo_Sequence_W = QLineEdit()
        self.paginadeci1_campo_Sequence_A = QPushButton('Apply')
        self.paginadeci1_campo_Sequence_A.clicked.connect(self.applica1sequenza)
        self.paginadeci1_campo_BunchNumberStart_L = QLabel('BunchNumber Start: ')
        self.paginadeci1_campo_BunchNumberStart_R = LineEditRO()
        self.paginadeci1_campo_BunchNumberStart_W = QLineEdit()
        self.paginadeci1_campo_BunchNumberStart_A = QPushButton('Apply')
        self.paginadeci1_campo_BunchNumberStart_A.clicked.connect(self.applica1bnstart)
        self.paginadeci1_campo_InfiniteCycle_L = QLabel('Infinite cycles')
        self.paginadeci1_campo_InfiniteCycle_R = LineEditRO()
        self.paginadeci1_campo_InfiniteCycle_true = QPushButton('On')
        self.paginadeci1_campo_InfiniteCycle_true.chiave = '1'
        self.paginadeci1_campo_InfiniteCycle_true.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci1_campo_InfiniteCycle_false = QPushButton('Off')
        self.paginadeci1_campo_InfiniteCycle_false.chiave = '1'
        self.paginadeci1_campo_InfiniteCycle_false.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci1_campo_MaxNumCycles_L = QLabel('Max num Cycles: ')
        self.paginadeci1_campo_MaxNumCycles_R = LineEditRO()
        self.paginadeci1_campo_MaxNumCycles_W = QLineEdit()
        self.paginadeci1_campo_MaxNumCycles_A = QPushButton('Apply')
        self.paginadeci1_campo_MaxNumCycles_A.clicked.connect(self.applica1MaxNumCycles)
        self.paginadeci1_campo_BunchNumberEnd_L = QLabel('BunchNumber End: ')
        self.paginadeci1_campo_BunchNumberEnd_R = LineEditRO()
        self.paginadeci1_campo_DelayOffset_L = QLabel('Delay offset: ')
        self.paginadeci1_campo_DelayOffset_R = LineEditRO()
        self.paginadeci1_campo_DelayOffset_W = QLineEdit()
        self.paginadeci1_campo_DelayOffset_A = QPushButton('Apply')     
        self.paginadeci1_campo_DelayOffset_A.clicked.connect(self.applica1DelayOffset)
        self.paginadeci1_campo_PolarityMode_L = QLabel('Polarity mode')
        self.paginadeci1_campo_PolarityMode_R = LineEditRO()
        self.paginadeci1_campo_PolarityMode_true = QPushButton('On')
        self.paginadeci1_campo_PolarityMode_true.chiave = '1'
        self.paginadeci1_campo_PolarityMode_true.clicked.connect(self.applicaPolarityMode)
        self.paginadeci1_campo_PolarityMode_false = QPushButton('Off')
        self.paginadeci1_campo_PolarityMode_false.chiave = '1'
        self.paginadeci1_campo_PolarityMode_false.clicked.connect(self.applicaPolarityMode)
        self.paginadeci1_campo_ReverseMode_L = QLabel('Reverse mode')
        self.paginadeci1_campo_ReverseMode_R = LineEditRO()
        self.paginadeci1_campo_ReverseMode_true = QPushButton('On')
        self.paginadeci1_campo_ReverseMode_true.chiave = '1'
        self.paginadeci1_campo_ReverseMode_true.clicked.connect(self.applicaReverseMode)
        self.paginadeci1_campo_ReverseMode_false = QPushButton('Off')
        self.paginadeci1_campo_ReverseMode_false.chiave = '1'
        self.paginadeci1_campo_ReverseMode_false.clicked.connect(self.applicaReverseMode)
        self.LOpaginadeci1 = QGridLayout()
        self.LOpaginadeci1.addWidget(self.paginadeci1_info1, 0, 0, 1, 4)
        self.LOpaginadeci1.addWidget(self.paginadeci1_info2, 1, 0, 1, 4)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_StateL, 2, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_State, 2, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_StatusL, 3, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_Status, 3, 1, 1, 3)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_mode, 10, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_modeR, 10, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_DelayMode, 10, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_StatusMode, 10, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_partipari, 11, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_partidispari, 11, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_on, 11, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_off, 11, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_Sequence_L, 20, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_Sequence_R, 20, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_Sequence_W, 20, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_Sequence_A, 20, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_BunchNumberStart_L, 21, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_BunchNumberStart_R, 21, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_BunchNumberStart_W, 21, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_BunchNumberStart_A, 21, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_InfiniteCycle_L, 32, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_InfiniteCycle_R, 32, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_InfiniteCycle_true, 32, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_InfiniteCycle_false, 32, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_MaxNumCycles_L, 33, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_MaxNumCycles_R, 33, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_MaxNumCycles_W, 33, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_MaxNumCycles_A, 33, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_BunchNumberEnd_L, 34, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_BunchNumberEnd_R, 34, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_DelayOffset_L, 35, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_DelayOffset_R, 35, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_DelayOffset_W, 35, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_DelayOffset_A, 35, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_PolarityMode_L, 36, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_PolarityMode_R, 36, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_PolarityMode_true, 36, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_PolarityMode_false, 36, 3, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_ReverseMode_L, 37, 0, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_ReverseMode_R, 37, 1, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_ReverseMode_true, 37, 2, 1, 1)
        self.LOpaginadeci1.addWidget(self.paginadeci1_campo_ReverseMode_false, 37, 3, 1, 1)
        self.paginadeci1.setLayout(self.LOpaginadeci1)
        #
        self.paginadeci2 = QFrame()
        self.paginadeci2_info1 = QLabel('Decimator for SEED')
        self.paginadeci2_campo_StateL = QLabel('State(misleading): ')
        self.paginadeci2_campo_State = LineEditRO()
        self.paginadeci2_campo_StatusL = QLabel('Status: ')
        self.paginadeci2_campo_Status = LineEditRO()
        self.paginadeci2_campo_mode = QLabel('MODE:')
        self.paginadeci2_campo_modeR = LineEditRO()
        self.paginadeci2_campo_DelayMode = QPushButton('DELAY')
        self.paginadeci2_campo_DelayMode.chiave = '2'
        self.paginadeci2_campo_DelayMode.clicked.connect(self.sceltadelay)
        self.paginadeci2_campo_StatusMode = QPushButton('STATUS')
        self.paginadeci2_campo_StatusMode.chiave = '2'
        self.paginadeci2_campo_StatusMode.clicked.connect(self.sceltastatus)
        self.paginadeci2_off = QPushButton('OFF')
        self.paginadeci2_off.clicked.connect(self.spegni3)
        self.paginadeci2_on = QPushButton('START (random)')
        self.paginadeci2_on.clicked.connect(self.accendi2_nobn)
        self.paginadeci2_partipari = QPushButton('START even')
        self.paginadeci2_partipari.clicked.connect(self.accendi2_even)
        self.paginadeci2_partidispari = QPushButton('START odd')
        self.paginadeci2_partidispari.clicked.connect(self.accendi2_odd)
        self.paginadeci2_campo_Sequence_L = QLabel('Sequence: ')
        self.paginadeci2_campo_Sequence_R = LineEditRO()
        self.paginadeci2_campo_Sequence_W = QLineEdit()
        self.paginadeci2_campo_Sequence_A = QPushButton('Apply')
        self.paginadeci2_campo_Sequence_A.clicked.connect(self.applica2sequenza)
        self.paginadeci2_campo_BunchNumberStart_L = QLabel('BunchNumber Start: ')
        self.paginadeci2_campo_BunchNumberStart_R = LineEditRO()
        self.paginadeci2_campo_BunchNumberStart_W = QLineEdit()
        self.paginadeci2_campo_BunchNumberStart_A = QPushButton('Apply')
        self.paginadeci2_campo_BunchNumberStart_A.clicked.connect(self.applica2bnstart)
        self.paginadeci2_campo_InfiniteCycle_L = QLabel('Infinite cycles')
        self.paginadeci2_campo_InfiniteCycle_R = LineEditRO()
        self.paginadeci2_campo_InfiniteCycle_true = QPushButton('On')
        self.paginadeci2_campo_InfiniteCycle_true.chiave = '2'
        self.paginadeci2_campo_InfiniteCycle_true.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci2_campo_InfiniteCycle_false = QPushButton('Off')
        self.paginadeci2_campo_InfiniteCycle_false.chiave = '2'
        self.paginadeci2_campo_InfiniteCycle_false.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci2_campo_MaxNumCycles_L = QLabel('Max num Cycles: ')
        self.paginadeci2_campo_MaxNumCycles_R = LineEditRO()
        self.paginadeci2_campo_MaxNumCycles_W = QLineEdit()
        self.paginadeci2_campo_MaxNumCycles_A = QPushButton('Apply')
        self.paginadeci2_campo_MaxNumCycles_A.clicked.connect(self.applica2MaxNumCycles)
        self.paginadeci2_campo_BunchNumberEnd_L = QLabel('BunchNumber End: ')
        self.paginadeci2_campo_BunchNumberEnd_R = LineEditRO()
        self.paginadeci2_campo_DelayOffset_L = QLabel('Delay offset: ')
        self.paginadeci2_campo_DelayOffset_R = LineEditRO()
        self.paginadeci2_campo_DelayOffset_W = QLineEdit()
        self.paginadeci2_campo_DelayOffset_A = QPushButton('Apply')      
        self.paginadeci2_campo_DelayOffset_A.clicked.connect(self.applica2DelayOffset)
        self.paginadeci2_campo_PolarityMode_L = QLabel('Polarity mode')
        self.paginadeci2_campo_PolarityMode_R = LineEditRO()
        self.paginadeci2_campo_PolarityMode_true = QPushButton('On')
        self.paginadeci2_campo_PolarityMode_true.chiave = '2'
        self.paginadeci2_campo_PolarityMode_true.clicked.connect(self.applicaPolarityMode)
        self.paginadeci2_campo_PolarityMode_false = QPushButton('Off')
        self.paginadeci2_campo_PolarityMode_false.chiave = '2'
        self.paginadeci2_campo_PolarityMode_false.clicked.connect(self.applicaPolarityMode)
        self.paginadeci2_campo_ReverseMode_L = QLabel('Reverse mode')
        self.paginadeci2_campo_ReverseMode_R = LineEditRO()
        self.paginadeci2_campo_ReverseMode_true = QPushButton('On')
        self.paginadeci2_campo_ReverseMode_true.chiave = '2'
        self.paginadeci2_campo_ReverseMode_true.clicked.connect(self.applicaReverseMode)
        self.paginadeci2_campo_ReverseMode_false = QPushButton('Off')
        self.paginadeci2_campo_ReverseMode_false.chiave = '2'
        self.paginadeci2_campo_ReverseMode_false.clicked.connect(self.applicaReverseMode)
        self.LOpaginadeci2 = QGridLayout()
        self.LOpaginadeci2.addWidget(self.paginadeci2_info1, 0, 0, 1, 4)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_StateL, 2, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_State, 2, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_StatusL, 3, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_Status, 3, 1, 1, 3)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_mode, 10, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_modeR, 10, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_DelayMode, 10, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_StatusMode, 10, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_partipari, 11, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_partidispari, 11, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_on, 11, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_off, 11, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_Sequence_L, 20, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_Sequence_R, 20, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_Sequence_W, 20, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_Sequence_A, 20, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_BunchNumberStart_L, 21, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_BunchNumberStart_R, 21, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_BunchNumberStart_W, 21, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_BunchNumberStart_A, 21, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_InfiniteCycle_L, 32, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_InfiniteCycle_R, 32, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_InfiniteCycle_true, 32, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_InfiniteCycle_false, 32, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_MaxNumCycles_L, 33, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_MaxNumCycles_R, 33, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_MaxNumCycles_W, 33, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_MaxNumCycles_A, 33, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_BunchNumberEnd_L, 34, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_BunchNumberEnd_R, 34, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_DelayOffset_L, 35, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_DelayOffset_R, 35, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_DelayOffset_W, 35, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_DelayOffset_A, 35, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_PolarityMode_L, 36, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_PolarityMode_R, 36, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_PolarityMode_true, 36, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_PolarityMode_false, 36, 3, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_ReverseMode_L, 37, 0, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_ReverseMode_R, 37, 1, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_ReverseMode_true, 37, 2, 1, 1)
        self.LOpaginadeci2.addWidget(self.paginadeci2_campo_ReverseMode_false, 37, 3, 1, 1)
        self.paginadeci2.setLayout(self.LOpaginadeci2)
        #
        self.paginadeci3 = QFrame()
        self.paginadeci3_info1 = QLabel('Decimator for SLU')
        self.paginadeci3_campo_StateL = QLabel('State(misleading): ')
        self.paginadeci3_campo_State = LineEditRO()
        self.paginadeci3_campo_StatusL = QLabel('Status: ')
        self.paginadeci3_campo_Status = LineEditRO()
        self.paginadeci3_campo_mode = QLabel('MODE:')
        self.paginadeci3_campo_modeR = LineEditRO()
        self.paginadeci3_campo_DelayMode = QPushButton('DELAY')
        self.paginadeci3_campo_DelayMode.chiave = '3'
        self.paginadeci3_campo_DelayMode.clicked.connect(self.sceltadelay)
        self.paginadeci3_campo_StatusMode = QPushButton('STATUS')
        self.paginadeci3_campo_StatusMode.chiave = '3'
        self.paginadeci3_campo_StatusMode.clicked.connect(self.sceltastatus)
        self.paginadeci3_off = QPushButton('OFF')
        self.paginadeci3_off.clicked.connect(self.spegni3)
        self.paginadeci3_on = QPushButton('START (random)')
        self.paginadeci3_on.clicked.connect(self.accendi3_nobn)
        self.paginadeci3_partipari = QPushButton('START even')
        self.paginadeci3_partipari.clicked.connect(self.accendi3_even)
        self.paginadeci3_partidispari = QPushButton('START odd')
        self.paginadeci3_partidispari.clicked.connect(self.accendi3_odd)
        self.paginadeci3_partibn = QPushButton('START at bunchnumber')
        self.paginadeci3_partibn.clicked.connect(self.accendi3_bn)
        self.paginadeci3_updatebn_plus5s = QPushButton('Update bn + 5sec')
        self.paginadeci3_updatebn_plus5s.clicked.connect(self.aggiorna3bn)
        self.paginadeci3_campo_Sequence_L = QLabel('Sequence: ')
        self.paginadeci3_campo_Sequence_R = LineEditRO()
        self.paginadeci3_campo_Sequence_W = QLineEdit()
        self.paginadeci3_campo_Sequence_A = QPushButton('Apply')
        self.paginadeci3_campo_Sequence_A.clicked.connect(self.applica3sequenza)
        self.paginadeci3_campo_BunchNumberStart_L = QLabel('BunchNumber Start: ')
        self.paginadeci3_campo_BunchNumberStart_R = LineEditRO()
        self.paginadeci3_campo_BunchNumberStart_W = QLineEdit()
        self.paginadeci3_campo_BunchNumberStart_A = QPushButton('Apply')
        self.paginadeci3_campo_BunchNumberStart_A.clicked.connect(self.applica3bnstart)
        self.paginadeci3_campo_InfiniteCycle_L = QLabel('Infinite cycles')
        self.paginadeci3_campo_InfiniteCycle_R = LineEditRO()
        self.paginadeci3_campo_InfiniteCycle_true = QPushButton('On')
        self.paginadeci3_campo_InfiniteCycle_true.chiave = '3'
        self.paginadeci3_campo_InfiniteCycle_true.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci3_campo_InfiniteCycle_false = QPushButton('Off')
        self.paginadeci3_campo_InfiniteCycle_false.chiave = '3'
        self.paginadeci3_campo_InfiniteCycle_false.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci3_campo_MaxNumCycles_L = QLabel('Max num Cycles: ')
        self.paginadeci3_campo_MaxNumCycles_R = LineEditRO()
        self.paginadeci3_campo_MaxNumCycles_W = QLineEdit()
        self.paginadeci3_campo_MaxNumCycles_A = QPushButton('Apply')
        self.paginadeci3_campo_MaxNumCycles_A.clicked.connect(self.applica3MaxNumCycles)
        self.paginadeci3_campo_BunchNumberEnd_L = QLabel('BunchNumber End: ')
        self.paginadeci3_campo_BunchNumberEnd_R = LineEditRO()
        self.paginadeci3_campo_DelayOffset_L = QLabel('Delay offset: ')
        self.paginadeci3_campo_DelayOffset_R = LineEditRO()
        self.paginadeci3_campo_DelayOffset_W = QLineEdit()
        self.paginadeci3_campo_DelayOffset_A = QPushButton('Apply')       
        self.paginadeci3_campo_DelayOffset_A.clicked.connect(self.applica3DelayOffset)
        self.paginadeci3_campo_PolarityMode_L = QLabel('Polarity mode')
        self.paginadeci3_campo_PolarityMode_R = LineEditRO()
        self.paginadeci3_campo_PolarityMode_true = QPushButton('On')
        self.paginadeci3_campo_PolarityMode_true.chiave = '3'
        self.paginadeci3_campo_PolarityMode_true.clicked.connect(self.applicaPolarityMode)
        self.paginadeci3_campo_PolarityMode_false = QPushButton('Off')
        self.paginadeci3_campo_PolarityMode_false.chiave = '3'
        self.paginadeci3_campo_PolarityMode_false.clicked.connect(self.applicaPolarityMode)
        self.paginadeci3_campo_ReverseMode_L = QLabel('Reverse mode')
        self.paginadeci3_campo_ReverseMode_R = LineEditRO()
        self.paginadeci3_campo_ReverseMode_true = QPushButton('On')
        self.paginadeci3_campo_ReverseMode_true.chiave = '3'
        self.paginadeci3_campo_ReverseMode_true.clicked.connect(self.applicaReverseMode)
        self.paginadeci3_campo_ReverseMode_false = QPushButton('Off')
        self.paginadeci3_campo_ReverseMode_false.chiave = '3'
        self.paginadeci3_campo_ReverseMode_false.clicked.connect(self.applicaReverseMode)
        self.LOpaginadeci3 = QGridLayout()
        self.LOpaginadeci3.addWidget(self.paginadeci3_info1, 0, 0, 1, 4)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_StateL, 2, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_State, 2, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_StatusL, 3, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_Status, 3, 1, 1, 3)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_mode, 10, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_modeR, 10, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_DelayMode, 10, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_StatusMode, 10, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_partipari, 11, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_partidispari, 11, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_on, 11, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_off, 11, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_Sequence_L, 20, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_Sequence_R, 20, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_Sequence_W, 20, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_Sequence_A, 20, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_BunchNumberStart_L, 21, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_BunchNumberStart_R, 21, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_BunchNumberStart_W, 21, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_BunchNumberStart_A, 21, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_updatebn_plus5s, 22, 0, 1, 2)
        self.LOpaginadeci3.addWidget(self.paginadeci3_partibn, 22, 2, 1, 2)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_InfiniteCycle_L, 32, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_InfiniteCycle_R, 32, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_InfiniteCycle_true, 32, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_InfiniteCycle_false, 32, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_MaxNumCycles_L, 33, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_MaxNumCycles_R, 33, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_MaxNumCycles_W, 33, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_MaxNumCycles_A, 33, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_BunchNumberEnd_L, 34, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_BunchNumberEnd_R, 34, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_DelayOffset_L, 35, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_DelayOffset_R, 35, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_DelayOffset_W, 35, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_DelayOffset_A, 35, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_PolarityMode_L, 36, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_PolarityMode_R, 36, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_PolarityMode_true, 36, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_PolarityMode_false, 36, 3, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_ReverseMode_L, 37, 0, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_ReverseMode_R, 37, 1, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_ReverseMode_true, 37, 2, 1, 1)
        self.LOpaginadeci3.addWidget(self.paginadeci3_campo_ReverseMode_false, 37, 3, 1, 1)
        self.paginadeci3.setLayout(self.LOpaginadeci3)
        #
        self.paginadeci4 = QFrame()
        self.paginadeci4_info1 = QLabel('Amplifier 1 without diagnostics')
        self.paginadeci4_info2 = QLabel('')
        self.paginadeci4_campo_StateL = QLabel('State(misleading): ')
        self.paginadeci4_campo_State = LineEditRO()
        self.paginadeci4_campo_StatusL = QLabel('Status: ')
        self.paginadeci4_campo_Status = LineEditRO()
        self.paginadeci4_campo_mode = QLabel('MODE:')
        self.paginadeci4_campo_modeR = LineEditRO()
        self.paginadeci4_campo_DelayMode = QPushButton('DELAY')
        self.paginadeci4_campo_DelayMode.chiave = '4'
        self.paginadeci4_campo_DelayMode.clicked.connect(self.sceltadelay)
        self.paginadeci4_campo_StatusMode = QPushButton('STATUS')
        self.paginadeci4_campo_StatusMode.chiave = '4'
        self.paginadeci4_campo_StatusMode.clicked.connect(self.sceltastatus)
        self.paginadeci4_off = QPushButton('OFF')
        self.paginadeci4_off.clicked.connect(self.spegni3)
        self.paginadeci4_on = QPushButton('START (random)')
        self.paginadeci4_on.clicked.connect(self.accendi4_nobn)
        self.paginadeci4_partipari = QPushButton('START even')
        self.paginadeci4_partipari.clicked.connect(self.accendi4_even)
        self.paginadeci4_partidispari = QPushButton('START odd')
        self.paginadeci4_partidispari.clicked.connect(self.accendi4_odd)
        self.paginadeci4_campo_Sequence_L = QLabel('Sequence: ')
        self.paginadeci4_campo_Sequence_R = LineEditRO()
        self.paginadeci4_campo_Sequence_W = QLineEdit()
        self.paginadeci4_campo_Sequence_A = QPushButton('Apply')
        self.paginadeci4_campo_Sequence_A.clicked.connect(self.applica4sequenza)
        self.paginadeci4_campo_BunchNumberStart_L = QLabel('BunchNumber Start: ')
        self.paginadeci4_campo_BunchNumberStart_R = LineEditRO()
        self.paginadeci4_campo_BunchNumberStart_W = QLineEdit()
        self.paginadeci4_campo_BunchNumberStart_A = QPushButton('Apply')
        self.paginadeci4_campo_BunchNumberStart_A.clicked.connect(self.applica4bnstart)
        self.paginadeci4_campo_InfiniteCycle_L = QLabel('Infinite cycles')
        self.paginadeci4_campo_InfiniteCycle_R = LineEditRO()
        self.paginadeci4_campo_InfiniteCycle_true = QPushButton('On')
        self.paginadeci4_campo_InfiniteCycle_true.chiave = '4'
        self.paginadeci4_campo_InfiniteCycle_true.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci4_campo_InfiniteCycle_false = QPushButton('Off')
        self.paginadeci4_campo_InfiniteCycle_false.chiave = '4'
        self.paginadeci4_campo_InfiniteCycle_false.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci4_campo_MaxNumCycles_L = QLabel('Max num Cycles: ')
        self.paginadeci4_campo_MaxNumCycles_R = LineEditRO()
        self.paginadeci4_campo_MaxNumCycles_W = QLineEdit()
        self.paginadeci4_campo_MaxNumCycles_A = QPushButton('Apply')
        self.paginadeci4_campo_MaxNumCycles_A.clicked.connect(self.applica4MaxNumCycles)
        self.paginadeci4_campo_BunchNumberEnd_L = QLabel('BunchNumber End: ')
        self.paginadeci4_campo_BunchNumberEnd_R = LineEditRO()
        self.paginadeci4_campo_DelayOffset_L = QLabel('Delay offset: ')
        self.paginadeci4_campo_DelayOffset_R = LineEditRO()
        self.paginadeci4_campo_DelayOffset_W = QLineEdit()
        self.paginadeci4_campo_DelayOffset_A = QPushButton('Apply')     
        self.paginadeci4_campo_DelayOffset_A.clicked.connect(self.applica4DelayOffset)
        self.paginadeci4_campo_PolarityMode_L = QLabel('Polarity mode')
        self.paginadeci4_campo_PolarityMode_R = LineEditRO()
        self.paginadeci4_campo_PolarityMode_true = QPushButton('On')
        self.paginadeci4_campo_PolarityMode_true.chiave = '4'
        self.paginadeci4_campo_PolarityMode_true.clicked.connect(self.applicaPolarityMode)
        self.paginadeci4_campo_PolarityMode_false = QPushButton('Off')
        self.paginadeci4_campo_PolarityMode_false.chiave = '4'
        self.paginadeci4_campo_PolarityMode_false.clicked.connect(self.applicaPolarityMode)
        self.paginadeci4_campo_ReverseMode_L = QLabel('Reverse mode')
        self.paginadeci4_campo_ReverseMode_R = LineEditRO()
        self.paginadeci4_campo_ReverseMode_true = QPushButton('On')
        self.paginadeci4_campo_ReverseMode_true.chiave = '4'
        self.paginadeci4_campo_ReverseMode_true.clicked.connect(self.applicaReverseMode)
        self.paginadeci4_campo_ReverseMode_false = QPushButton('Off')
        self.paginadeci4_campo_ReverseMode_false.chiave = '4'
        self.paginadeci4_campo_ReverseMode_false.clicked.connect(self.applicaReverseMode)
        self.LOpaginadeci4 = QGridLayout()
        self.LOpaginadeci4.addWidget(self.paginadeci4_info1, 0, 0, 1, 4)
        self.LOpaginadeci4.addWidget(self.paginadeci4_info2, 1, 0, 1, 4)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_StateL, 2, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_State, 2, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_StatusL, 3, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_Status, 3, 1, 1, 3)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_mode, 10, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_modeR, 10, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_DelayMode, 10, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_StatusMode, 10, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_partipari, 11, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_partidispari, 11, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_on, 11, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_off, 11, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_Sequence_L, 20, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_Sequence_R, 20, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_Sequence_W, 20, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_Sequence_A, 20, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_BunchNumberStart_L, 21, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_BunchNumberStart_R, 21, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_BunchNumberStart_W, 21, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_BunchNumberStart_A, 21, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_InfiniteCycle_L, 32, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_InfiniteCycle_R, 32, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_InfiniteCycle_true, 32, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_InfiniteCycle_false, 32, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_MaxNumCycles_L, 33, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_MaxNumCycles_R, 33, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_MaxNumCycles_W, 33, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_MaxNumCycles_A, 33, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_BunchNumberEnd_L, 34, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_BunchNumberEnd_R, 34, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_DelayOffset_L, 35, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_DelayOffset_R, 35, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_DelayOffset_W, 35, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_DelayOffset_A, 35, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_PolarityMode_L, 36, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_PolarityMode_R, 36, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_PolarityMode_true, 36, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_PolarityMode_false, 36, 3, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_ReverseMode_L, 37, 0, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_ReverseMode_R, 37, 1, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_ReverseMode_true, 37, 2, 1, 1)
        self.LOpaginadeci4.addWidget(self.paginadeci4_campo_ReverseMode_false, 37, 3, 1, 1)
        self.paginadeci4.setLayout(self.LOpaginadeci4)
        #
        self.paginadeci5 = QFrame()
        self.paginadeci5_info1 = QLabel('Amplifier 2 without diagnostics')
        self.paginadeci5_info2 = QLabel('')
        self.paginadeci5_campo_StateL = QLabel('State(misleading): ')
        self.paginadeci5_campo_State = LineEditRO()
        self.paginadeci5_campo_StatusL = QLabel('Status: ')
        self.paginadeci5_campo_Status = LineEditRO()
        self.paginadeci5_campo_mode = QLabel('MODE:')
        self.paginadeci5_campo_modeR = LineEditRO()
        self.paginadeci5_campo_DelayMode = QPushButton('DELAY')
        self.paginadeci5_campo_DelayMode.chiave = '5'
        self.paginadeci5_campo_DelayMode.clicked.connect(self.sceltadelay)
        self.paginadeci5_campo_StatusMode = QPushButton('STATUS')
        self.paginadeci5_campo_StatusMode.chiave = '5'
        self.paginadeci5_campo_StatusMode.clicked.connect(self.sceltastatus)
        self.paginadeci5_off = QPushButton('OFF')
        self.paginadeci5_off.clicked.connect(self.spegni3)
        self.paginadeci5_on = QPushButton('START (random)')
        self.paginadeci5_on.clicked.connect(self.accendi5_nobn)
        self.paginadeci5_partipari = QPushButton('START even')
        self.paginadeci5_partipari.clicked.connect(self.accendi5_even)
        self.paginadeci5_partidispari = QPushButton('START odd')
        self.paginadeci5_partidispari.clicked.connect(self.accendi5_odd)
        self.paginadeci5_campo_Sequence_L = QLabel('Sequence: ')
        self.paginadeci5_campo_Sequence_R = LineEditRO()
        self.paginadeci5_campo_Sequence_W = QLineEdit()
        self.paginadeci5_campo_Sequence_A = QPushButton('Apply')
        self.paginadeci5_campo_Sequence_A.clicked.connect(self.applica5sequenza)
        self.paginadeci5_campo_BunchNumberStart_L = QLabel('BunchNumber Start: ')
        self.paginadeci5_campo_BunchNumberStart_R = LineEditRO()
        self.paginadeci5_campo_BunchNumberStart_W = QLineEdit()
        self.paginadeci5_campo_BunchNumberStart_A = QPushButton('Apply')
        self.paginadeci5_campo_BunchNumberStart_A.clicked.connect(self.applica5bnstart)
        self.paginadeci5_campo_InfiniteCycle_L = QLabel('Infinite cycles')
        self.paginadeci5_campo_InfiniteCycle_R = LineEditRO()
        self.paginadeci5_campo_InfiniteCycle_true = QPushButton('On')
        self.paginadeci5_campo_InfiniteCycle_true.chiave = '5'
        self.paginadeci5_campo_InfiniteCycle_true.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci5_campo_InfiniteCycle_false = QPushButton('Off')
        self.paginadeci5_campo_InfiniteCycle_false.chiave = '5'
        self.paginadeci5_campo_InfiniteCycle_false.clicked.connect(self.applicaInfiniteCycle)
        self.paginadeci5_campo_MaxNumCycles_L = QLabel('Max num Cycles: ')
        self.paginadeci5_campo_MaxNumCycles_R = LineEditRO()
        self.paginadeci5_campo_MaxNumCycles_W = QLineEdit()
        self.paginadeci5_campo_MaxNumCycles_A = QPushButton('Apply')
        self.paginadeci5_campo_MaxNumCycles_A.clicked.connect(self.applica5MaxNumCycles)
        self.paginadeci5_campo_BunchNumberEnd_L = QLabel('BunchNumber End: ')
        self.paginadeci5_campo_BunchNumberEnd_R = LineEditRO()
        self.paginadeci5_campo_DelayOffset_L = QLabel('Delay offset: ')
        self.paginadeci5_campo_DelayOffset_R = LineEditRO()
        self.paginadeci5_campo_DelayOffset_W = QLineEdit()
        self.paginadeci5_campo_DelayOffset_A = QPushButton('Apply')       
        self.paginadeci5_campo_DelayOffset_A.clicked.connect(self.applica5DelayOffset)
        self.paginadeci5_campo_PolarityMode_L = QLabel('Polarity mode')
        self.paginadeci5_campo_PolarityMode_R = LineEditRO()
        self.paginadeci5_campo_PolarityMode_true = QPushButton('On')
        self.paginadeci5_campo_PolarityMode_true.chiave = '5'
        self.paginadeci5_campo_PolarityMode_true.clicked.connect(self.applicaPolarityMode)
        self.paginadeci5_campo_PolarityMode_false = QPushButton('Off')
        self.paginadeci5_campo_PolarityMode_false.chiave = '5'
        self.paginadeci5_campo_PolarityMode_false.clicked.connect(self.applicaPolarityMode)
        self.paginadeci5_campo_ReverseMode_L = QLabel('Reverse mode')
        self.paginadeci5_campo_ReverseMode_R = LineEditRO()
        self.paginadeci5_campo_ReverseMode_true = QPushButton('On')
        self.paginadeci5_campo_ReverseMode_true.chiave = '5'
        self.paginadeci5_campo_ReverseMode_true.clicked.connect(self.applicaReverseMode)
        self.paginadeci5_campo_ReverseMode_false = QPushButton('Off')
        self.paginadeci5_campo_ReverseMode_false.chiave = '5'
        self.paginadeci5_campo_ReverseMode_false.clicked.connect(self.applicaReverseMode)
        self.LOpaginadeci5 = QGridLayout()
        self.LOpaginadeci5.addWidget(self.paginadeci5_info1, 0, 0, 1, 4)
        self.LOpaginadeci5.addWidget(self.paginadeci5_info2, 1, 0, 1, 4)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_StateL, 2, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_State, 2, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_StatusL, 3, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_Status, 3, 1, 1, 3)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_mode, 10, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_modeR, 10, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_DelayMode, 10, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_StatusMode, 10, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_partipari, 11, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_partidispari, 11, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_on, 11, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_off, 11, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_Sequence_L, 20, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_Sequence_R, 20, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_Sequence_W, 20, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_Sequence_A, 20, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_BunchNumberStart_L, 21, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_BunchNumberStart_R, 21, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_BunchNumberStart_W, 21, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_BunchNumberStart_A, 21, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_InfiniteCycle_L, 32, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_InfiniteCycle_R, 32, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_InfiniteCycle_true, 32, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_InfiniteCycle_false, 32, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_MaxNumCycles_L, 33, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_MaxNumCycles_R, 33, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_MaxNumCycles_W, 33, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_MaxNumCycles_A, 33, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_BunchNumberEnd_L, 34, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_BunchNumberEnd_R, 34, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_DelayOffset_L, 35, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_DelayOffset_R, 35, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_DelayOffset_W, 35, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_DelayOffset_A, 35, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_PolarityMode_L, 36, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_PolarityMode_R, 36, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_PolarityMode_true, 36, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_PolarityMode_false, 36, 3, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_ReverseMode_L, 37, 0, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_ReverseMode_R, 37, 1, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_ReverseMode_true, 37, 2, 1, 1)
        self.LOpaginadeci5.addWidget(self.paginadeci5_campo_ReverseMode_false, 37, 3, 1, 1)
        self.paginadeci5.setLayout(self.LOpaginadeci5)
        #
        self.insertTab(0, self.paginagenerale, 'General')
        self.insertTab(1, self.paginadeci1, 'rttrigger_sl.01')
        self.insertTab(2, self.paginadeci2, 'rttrigger_sl.02')
        self.insertTab(3, self.paginadeci3, 'rttrigger_sl.03')
        self.insertTab(4, self.paginadeci4, 'rttrigger_sl.04')
        self.insertTab(5, self.paginadeci5, 'rttrigger_sl.05')
        self.setWindowTitle("SL/SLU DECIMATORS")
        self.show()
        #inizializzazione
        tmp = devicelist['1'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
        self.paginadeci1_campo_BunchNumberStart_W.setText(str(tmp[1].value))
        self.paginadeci1_campo_Sequence_W.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
        self.paginadeci1_campo_DelayOffset_W.setText(str(tmp[3].value))
        self.paginadeci1_campo_MaxNumCycles_W.setText(str(tmp[6].value))
        tmp = devicelist['2'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
        self.paginadeci2_campo_BunchNumberStart_W.setText(str(tmp[1].value))
        self.paginadeci2_campo_Sequence_W.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
        self.paginadeci2_campo_DelayOffset_W.setText(str(tmp[3].value))
        self.paginadeci2_campo_MaxNumCycles_W.setText(str(tmp[6].value))
        tmp = devicelist['3'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
        self.paginadeci3_campo_BunchNumberStart_W.setText(str(tmp[1].value))
        self.paginadeci3_campo_Sequence_W.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
        self.paginadeci3_campo_DelayOffset_W.setText(str(tmp[3].value))
        self.paginadeci3_campo_MaxNumCycles_W.setText(str(tmp[6].value))
        tmp = devicelist['4'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
        self.paginadeci4_campo_BunchNumberStart_W.setText(str(tmp[1].value))
        self.paginadeci4_campo_Sequence_W.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
        self.paginadeci4_campo_DelayOffset_W.setText(str(tmp[3].value))
        self.paginadeci4_campo_MaxNumCycles_W.setText(str(tmp[6].value))
        tmp = devicelist['5'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
        self.paginadeci5_campo_BunchNumberStart_W.setText(str(tmp[1].value))
        self.paginadeci5_campo_Sequence_W.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
        self.paginadeci5_campo_DelayOffset_W.setText(str(tmp[3].value))
        self.paginadeci5_campo_MaxNumCycles_W.setText(str(tmp[6].value))
        #timer
        self.timer = QBasicTimer()
        self.timer.start(1500, self)

    def timerEvent(self, event):
        self.update()

    def __del__(self):
        self.timer.stop()

    def update(self):
        try:
            tmp = devicelist['contollo'].read_attribute('ChannelsState')
            if selettore >= 1 and selettore <= 6: #elite1 x fel, elite2 x slu
                #decimatore 1
                if tmp.value[0] == 10 and tmp.value[1] == 10 and tmp.value[2] == 10 and tmp.value[3] == 10 and tmp.value[8] == 10 and tmp.value[10] == 10 and tmp.value[11] == 10:
                    self.paginagenerale_1facileindicatore.setText('ON')
                    self.paginagenerale_1facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_1facileindicatore.setText('OFF')
                    self.paginagenerale_1facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
                #decimatore 2
                if tmp.value[0] == 1 and tmp.value[1] == 10 and tmp.value[2] == 1 and tmp.value[10] == 10:
                    self.paginagenerale_2facileindicatore.setText('ON')
                    self.paginagenerale_2facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_2facileindicatore.setText('OFF')
                    self.paginagenerale_2facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
                #decimatore 3
                if tmp.value[0] == 1 and tmp.value[1] == 1 and tmp.value[2] == 10 and tmp.value[8] == 10 and tmp.value[11] == 10:
                    self.paginagenerale_3facileindicatore.setText('ON')
                    self.paginagenerale_3facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_3facileindicatore.setText('OFF')
                    self.paginagenerale_3facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
               #decimatore 4
                if tmp.value[0] == 1 and tmp.value[1] == 10 and tmp.value[2] == 1 and tmp.value[10] == 1:
                    self.paginagenerale_4facileindicatore.setText('ON')
                    self.paginagenerale_4facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_4facileindicatore.setText('OFF')
                    self.paginagenerale_4facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
                if tmp.value[0] == 1 and tmp.value[1] == 1 and tmp.value[2] == 10 and tmp.value[8] == 1 and tmp.value[11] == 1:
                    self.paginagenerale_5facileindicatore.setText('ON')
                    self.paginagenerale_5facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_5facileindicatore.setText('OFF')
                    self.paginagenerale_5facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
            elif selettore >= 7 and selettore <= 11: #elite1 x slu, elite2 x fel
                #decimatore 1
                if tmp.value[0] == 10 and tmp.value[1] == 10 and tmp.value[2] == 10 and tmp.value[3] == 10 and tmp.value[8] == 10 and tmp.value[10] == 10 and tmp.value[11] == 10:
                    self.paginagenerale_1facileindicatore.setText('ON')
                    self.paginagenerale_1facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_1facileindicatore.setText('OFF')
                    self.paginagenerale_1facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
                #decimatore 2
                if tmp.value[0] == 1 and tmp.value[1] == 10 and tmp.value[2] == 1 and tmp.value[8] == 10 and tmp.value[10] == 10:
                    self.paginagenerale_2facileindicatore.setText('ON')
                    self.paginagenerale_2facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_2facileindicatore.setText('OFF')
                    self.paginagenerale_2facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
                #decimatore 3
                if tmp.value[0] == 1 and tmp.value[1] == 1 and tmp.value[2] == 10 and tmp.value[11] == 10:
                    self.paginagenerale_3facileindicatore.setText('ON')
                    self.paginagenerale_3facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_3facileindicatore.setText('OFF')
                    self.paginagenerale_3facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
               #decimatore 4
                if tmp.value[0] == 1 and tmp.value[1] == 10 and tmp.value[2] == 1 and tmp.value[8] == 1 and tmp.value[10] == 1:
                    self.paginagenerale_4facileindicatore.setText('ON')
                    self.paginagenerale_4facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_4facileindicatore.setText('OFF')
                    self.paginagenerale_4facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
                if tmp.value[0] == 1 and tmp.value[1] == 1 and tmp.value[2] == 10 and tmp.value[11] == 1:
                    self.paginagenerale_5facileindicatore.setText('ON')
                    self.paginagenerale_5facileindicatore.setStyleSheet("background-color: rgb(255, 255, 255)")
                else:
                    self.paginagenerale_5facileindicatore.setText('OFF')
                    self.paginagenerale_5facileindicatore.setStyleSheet("background-color: rgb(200, 200, 200)")
        except:
            print('ao')
        try:
            tmp = devicelist['1'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
            self.paginadeci1_campo_BunchNumberEnd_R.setText(str(tmp[0].value))
            self.paginadeci1_campo_BunchNumberStart_R.setText(str(tmp[1].value))
            if tmp[2].value:
                self.paginadeci1_campo_modeR.setText('Delay')
                self.paginagenerale_1modalita.setText('Delay')
            self.paginadeci1_campo_DelayOffset_R.setText(str(tmp[3].value))
            if tmp[5].value:
                self.paginadeci1_campo_InfiniteCycle_R.setText('True')
            else:
                self.paginadeci1_campo_InfiniteCycle_R.setText('False')
            self.paginadeci1_campo_MaxNumCycles_R.setText(str(tmp[6].value))
            if tmp[7].value:
                self.paginadeci1_campo_PolarityMode_R.setText('True')
            else:
                self.paginadeci1_campo_PolarityMode_R.setText('False')
            if tmp[8].value:
                self.paginadeci1_campo_ReverseMode_R.setText('True')
            else:
                self.paginadeci1_campo_ReverseMode_R.setText('False')
            self.paginadeci1_campo_Sequence_R.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
            self.paginadeci1_campo_State.setText(str(tmp[11].value))
            self.paginadeci1_campo_Status.setText(str(tmp[12].value))
            if tmp[13].value:
                self.paginadeci1_campo_modeR.setText('Status')
                self.paginagenerale_1modalita.setText('Status')
        except:
            self.paginadeci1_campo_BunchNumberEnd_R.setText('#####')
            self.paginadeci1_campo_BunchNumberStart_R.setText('#####')
            self.paginadeci1_campo_modeR.setText('#####')
            self.paginagenerale_1modalita.setText('#####')
            self.paginadeci1_campo_DelayOffset_R.setText('#####')
            self.paginadeci1_campo_InfiniteCycle_R.setText('#####')
            self.paginadeci1_campo_MaxNumCycles_R.setText('#####')
            self.paginadeci1_campo_PolarityMode_R.setText('#####')
            self.paginadeci1_campo_ReverseMode_R.setText('#####')
            self.paginadeci1_campo_Sequence_R.setText('#####')
            self.paginadeci1_campo_State.setText('#####')
            self.paginadeci1_campo_Status.setText('#####')
        ##
        try:
            tmp = devicelist['2'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
            self.paginadeci2_campo_BunchNumberEnd_R.setText(str(tmp[0].value))
            self.paginadeci2_campo_BunchNumberStart_R.setText(str(tmp[1].value))
            if tmp[2].value:
                self.paginadeci2_campo_modeR.setText('Delay')
                self.paginagenerale_2modalita.setText('Delay')
            self.paginadeci2_campo_DelayOffset_R.setText(str(tmp[3].value))
            if tmp[5].value:
                self.paginadeci2_campo_InfiniteCycle_R.setText('True')
            else:
                self.paginadeci2_campo_InfiniteCycle_R.setText('False')
            self.paginadeci2_campo_MaxNumCycles_R.setText(str(tmp[6].value))
            if tmp[7].value:
                self.paginadeci2_campo_PolarityMode_R.setText('True')
            else:
                self.paginadeci2_campo_PolarityMode_R.setText('False')
            if tmp[8].value:
                self.paginadeci2_campo_ReverseMode_R.setText('True')
            else:
                self.paginadeci2_campo_ReverseMode_R.setText('False')
            self.paginadeci2_campo_Sequence_R.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
            self.paginadeci2_campo_State.setText(str(tmp[11].value))
            self.paginadeci2_campo_Status.setText(str(tmp[12].value))
            if tmp[13].value:
                self.paginadeci2_campo_modeR.setText('Status')
                self.paginagenerale_2modalita.setText('Status')
        except:
            self.paginadeci2_campo_BunchNumberEnd_R.setText('#####')
            self.paginadeci2_campo_BunchNumberStart_R.setText('#####')
            self.paginadeci2_campo_modeR.setText('#####')
            self.paginagenerale_2modalita.setText('#####')
            self.paginadeci2_campo_DelayOffset_R.setText('#####')
            self.paginadeci2_campo_InfiniteCycle_R.setText('#####')
            self.paginadeci2_campo_MaxNumCycles_R.setText('#####')
            self.paginadeci2_campo_PolarityMode_R.setText('#####')
            self.paginadeci2_campo_ReverseMode_R.setText('#####')
            self.paginadeci2_campo_Sequence_R.setText('#####')
            self.paginadeci2_campo_State.setText('#####')
            self.paginadeci2_campo_Status.setText('#####')
        ##
        try:
            tmp = devicelist['3'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
            self.paginadeci3_campo_BunchNumberEnd_R.setText(str(tmp[0].value))
            self.paginadeci3_campo_BunchNumberStart_R.setText(str(tmp[1].value))
            if tmp[2].value:
                self.paginadeci3_campo_modeR.setText('Delay')
                self.paginagenerale_3modalita.setText('Delay')
            self.paginadeci3_campo_DelayOffset_R.setText(str(tmp[3].value))
            if tmp[5].value:
                self.paginadeci3_campo_InfiniteCycle_R.setText('True')
            else:
                self.paginadeci3_campo_InfiniteCycle_R.setText('False')
            self.paginadeci3_campo_MaxNumCycles_R.setText(str(tmp[6].value))
            if tmp[7].value:
                self.paginadeci3_campo_PolarityMode_R.setText('True')
            else:
                self.paginadeci3_campo_PolarityMode_R.setText('False')
            if tmp[8].value:
                self.paginadeci3_campo_ReverseMode_R.setText('True')
            else:
                self.paginadeci3_campo_ReverseMode_R.setText('False')
            self.paginadeci3_campo_Sequence_R.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
            self.paginadeci3_campo_State.setText(str(tmp[11].value))
            self.paginadeci3_campo_Status.setText(str(tmp[12].value))
            if tmp[13].value:
                self.paginadeci3_campo_modeR.setText('Status')
                self.paginagenerale_3modalita.setText('Status')
        except:
            self.paginadeci3_campo_BunchNumberEnd_R.setText('#####')
            self.paginadeci3_campo_BunchNumberStart_R.setText('#####')
            self.paginadeci3_campo_modeR.setText('#####')
            self.paginagenerale_3modalita.setText('#####')
            self.paginadeci3_campo_DelayOffset_R.setText('#####')
            self.paginadeci3_campo_InfiniteCycle_R.setText('#####')
            self.paginadeci3_campo_MaxNumCycles_R.setText('#####')
            self.paginadeci3_campo_PolarityMode_R.setText('#####')
            self.paginadeci3_campo_ReverseMode_R.setText('#####')
            self.paginadeci3_campo_Sequence_R.setText('#####')
            self.paginadeci3_campo_State.setText('#####')
            self.paginadeci3_campo_Status.setText('#####')
        ##
        try:
            tmp = devicelist['4'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
            self.paginadeci4_campo_BunchNumberEnd_R.setText(str(tmp[0].value))
            self.paginadeci4_campo_BunchNumberStart_R.setText(str(tmp[1].value))
            if tmp[2].value:
                self.paginadeci4_campo_modeR.setText('Delay')
                self.paginagenerale_4modalita.setText('Delay')
            self.paginadeci4_campo_DelayOffset_R.setText(str(tmp[3].value))
            if tmp[5].value:
                self.paginadeci4_campo_InfiniteCycle_R.setText('True')
            else:
                self.paginadeci4_campo_InfiniteCycle_R.setText('False')
            self.paginadeci4_campo_MaxNumCycles_R.setText(str(tmp[6].value))
            if tmp[7].value:
                self.paginadeci4_campo_PolarityMode_R.setText('True')
            else:
                self.paginadeci4_campo_PolarityMode_R.setText('False')
            if tmp[8].value:
                self.paginadeci4_campo_ReverseMode_R.setText('True')
            else:
                self.paginadeci4_campo_ReverseMode_R.setText('False')
            self.paginadeci4_campo_Sequence_R.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
            self.paginadeci4_campo_State.setText(str(tmp[11].value))
            self.paginadeci4_campo_Status.setText(str(tmp[12].value))
            if tmp[13].value:
                self.paginadeci4_campo_modeR.setText('Status')
                self.paginagenerale_4modalita.setText('Status')
        except:
            self.paginadeci4_campo_BunchNumberEnd_R.setText('#####')
            self.paginadeci4_campo_BunchNumberStart_R.setText('#####')
            self.paginadeci4_campo_modeR.setText('#####')
            self.paginagenerale_4modalita.setText('#####')
            self.paginadeci4_campo_DelayOffset_R.setText('#####')
            self.paginadeci4_campo_InfiniteCycle_R.setText('#####')
            self.paginadeci4_campo_MaxNumCycles_R.setText('#####')
            self.paginadeci4_campo_PolarityMode_R.setText('#####')
            self.paginadeci4_campo_ReverseMode_R.setText('#####')
            self.paginadeci4_campo_Sequence_R.setText('#####')
            self.paginadeci4_campo_State.setText('#####')
            self.paginadeci4_campo_Status.setText('#####')
        ##
        try:
            tmp = devicelist['5'].read_attributes(['BunchNumberEnd', 'BunchNumberStart', 'DelayMode', 'DelayOffset', 'EnableStaticTriggerShift', 'InfiniteCycle', 'MaxNumCycles', 'PolarityMode', 'ReverseMode', 'SaveModes', 'Sequence', 'State', 'Status', 'StatusMode'])
            self.paginadeci5_campo_BunchNumberEnd_R.setText(str(tmp[0].value))
            self.paginadeci5_campo_BunchNumberStart_R.setText(str(tmp[1].value))
            if tmp[2].value:
                self.paginadeci5_campo_modeR.setText('Delay')
                self.paginagenerale_5modalita.setText('Delay')
            self.paginadeci5_campo_DelayOffset_R.setText(str(tmp[3].value))
            if tmp[5].value:
                self.paginadeci5_campo_InfiniteCycle_R.setText('True')
            else:
                self.paginadeci5_campo_InfiniteCycle_R.setText('False')
            self.paginadeci5_campo_MaxNumCycles_R.setText(str(tmp[6].value))
            if tmp[7].value:
                self.paginadeci5_campo_PolarityMode_R.setText('True')
            else:
                self.paginadeci5_campo_PolarityMode_R.setText('False')
            if tmp[8].value:
                self.paginadeci5_campo_ReverseMode_R.setText('True')
            else:
                self.paginadeci5_campo_ReverseMode_R.setText('False')
            self.paginadeci5_campo_Sequence_R.setText(str(tmp[10].value).replace('[', '').replace(']','').replace(' ', ', '))
            self.paginadeci5_campo_State.setText(str(tmp[11].value))
            self.paginadeci5_campo_Status.setText(str(tmp[12].value))
            if tmp[13].value:
                self.paginadeci5_campo_modeR.setText('Status')
                self.paginagenerale_5modalita.setText('Status')
        except:
            self.paginadeci5_campo_BunchNumberEnd_R.setText('#####')
            self.paginadeci5_campo_BunchNumberStart_R.setText('#####')
            self.paginadeci5_campo_modeR.setText('#####')
            self.paginagenerale_5modalita.setText('#####')
            self.paginadeci5_campo_DelayOffset_R.setText('#####')
            self.paginadeci5_campo_InfiniteCycle_R.setText('#####')
            self.paginadeci5_campo_MaxNumCycles_R.setText('#####')
            self.paginadeci5_campo_PolarityMode_R.setText('#####')
            self.paginadeci5_campo_ReverseMode_R.setText('#####')
            self.paginadeci5_campo_Sequence_R.setText('#####')
            self.paginadeci5_campo_State.setText('#####')
            self.paginadeci5_campo_Status.setText('#####')

    def accendi1_odd(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 50
        else:
            BunchNumberStart_new = BunchNumberStart_new + 51
        devicelist['1'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['1'].command_inout('Start', 1)

    def accendi1_even(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 51
        else:
            BunchNumberStart_new = BunchNumberStart_new + 50
        devicelist['1'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['1'].command_inout('Start', 1)

    def accendi1_nobn(self):
        devicelist['1'].command_inout('Start', 0)

    def accendi2_odd(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 50
        else:
            BunchNumberStart_new = BunchNumberStart_new + 51
        devicelist['2'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['2'].command_inout('Start', 1)

    def accendi2_even(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 51
        else:
            BunchNumberStart_new = BunchNumberStart_new + 50
        devicelist['2'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['2'].command_inout('Start', 1)

    def accendi2_nobn(self):
        devicelist['2'].command_inout('Start', 0)

    def aggiorna3bn(self):
        if devicelist['frequenza'].BunchNumberFrequency > 49.0:
            BunchNumberStart_new = devicelist['frequenza'].BunchNumber + 250
        else:
            BunchNumberStart_new = devicelist['frequenza'].BunchNumber + 50
        devicelist['3'].write_attribute('BunchNumberStart', BunchNumberStart_new)

    def accendi3_bn(self):
        devicelist['3'].command_inout('Start', 1)

    def accendi3_odd(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 50
        else:
            BunchNumberStart_new = BunchNumberStart_new + 51
        devicelist['3'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['3'].command_inout('Start', 1)

    def accendi3_even(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 51
        else:
            BunchNumberStart_new = BunchNumberStart_new + 50
        devicelist['3'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['3'].command_inout('Start', 1)

    def accendi3_nobn(self):
        devicelist['3'].command_inout('Start', 0)

    def accendi4_odd(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 50
        else:
            BunchNumberStart_new = BunchNumberStart_new + 51
        devicelist['4'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['4'].command_inout('Start', 1)

    def accendi4_even(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 51
        else:
            BunchNumberStart_new = BunchNumberStart_new + 50
        devicelist['4'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['4'].command_inout('Start', 1)

    def accendi4_nobn(self):
        devicelist['4'].command_inout('Start', 0)

    def accendi5_odd(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 50
        else:
            BunchNumberStart_new = BunchNumberStart_new + 51
        devicelist['5'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['5'].command_inout('Start', 1)

    def accendi5_even(self):
        BunchNumberStart_new = devicelist['frequenza'].BunchNumber
        if BunchNumberStart_new % 2 > 0:
            BunchNumberStart_new = BunchNumberStart_new + 51
        else:
            BunchNumberStart_new = BunchNumberStart_new + 50
        devicelist['5'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        devicelist['5'].command_inout('Start', 1)

    def accendi5_nobn(self):
        devicelist['5'].command_inout('Start', 0)

    def spegni1(self):
        devicelist['1'].command_inout('Stop')

    def spegni2(self):
        devicelist['2'].command_inout('Stop')

    def spegni3(self):
        devicelist['3'].command_inout('Stop')

    def spegni4(self):
        devicelist['4'].command_inout('Stop')

    def spegni5(self):
        devicelist['5'].command_inout('Stop')

    def sceltadelay(self):
        tmp = self.sender()
        print(tmp.chiave)
        devicelist[tmp.chiave].write_attribute('DelayMode', 1)
        devicelist[tmp.chiave].write_attribute('InfiniteCycle', 0)
        devicelist[tmp.chiave].write_attribute('InfiniteCycle', 1)

    def sceltastatus(self):
        tmp = self.sender()
        print(tmp.chiave)
        devicelist[tmp.chiave].write_attribute('StatusMode', 1)
        devicelist[tmp.chiave].write_attribute('InfiniteCycle', 0)
        devicelist[tmp.chiave].write_attribute('InfiniteCycle', 1)

    def applica1sequenza(self):
        try:
            frequenza1050 = devicelist['frequenza'].BunchNumberFrequency
        except:
            frequenza1050 = -1
        try:
            tmp = str(self.paginadeci1_campo_Sequence_W.text()).replace('[', '').replace(']','')
            if self.paginadeci1_campo_modeR.text() == 'Status':
                if tmp.count('0') > 4:
                    self.msgBox = QMessageBox()
                    self.msgBox.setIcon(QMessageBox.Question)
                    self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
                    self.msgBox.setText("Decimation is too strong, if the frequency of the laser is below " + str(int(frequenza1050/5)) + "Hz thermal effects might degradate beam quality. Are you sure you want to proceed?")
                    risp = self.msgBox.exec_()
                    if risp == 1024:
                        Sequence_new = [int(aa) for aa in tmp.split(',')]
                        devicelist['1'].write_attribute('Sequence', Sequence_new)
                    else:
                        return
                else:
                    Sequence_new = [int(aa) for aa in tmp.split(',')]
                    devicelist['1'].write_attribute('Sequence', Sequence_new)
            else:
                Sequence_new = [int(aa) for aa in tmp.split(',')]
                devicelist['1'].write_attribute('Sequence', Sequence_new)
        except:
            print('error  ' + str(self.paginadeci1_campo_Sequence_W.text()))

    def applica2sequenza(self):
        try:
            frequenza1050 = devicelist['frequenza'].BunchNumberFrequency
        except:
            frequenza1050 = -1
        try:
            tmp = str(self.paginadeci2_campo_Sequence_W.text()).replace('[', '').replace(']','')
            if self.paginadeci2_campo_modeR.text() == 'Status':
                if tmp.count('0') > 4:
                    self.msgBox = QMessageBox()
                    self.msgBox.setIcon(QMessageBox.Question)
                    self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
                    self.msgBox.setText("Decimation is too strong, if the frequency of the laser is below " + str(int(frequenza1050/5)) + "Hz thermal effects might degradate beam quality. Are you sure you want to proceed?")
                    risp = self.msgBox.exec_()
                    if risp == 1024:
                        Sequence_new = [int(aa) for aa in tmp.split(',')]
                        devicelist['2'].write_attribute('Sequence', Sequence_new)
                    else:
                        return
                else:
                    Sequence_new = [int(aa) for aa in tmp.split(',')]
                    devicelist['2'].write_attribute('Sequence', Sequence_new)
            else:
                Sequence_new = [int(aa) for aa in tmp.split(',')]
                devicelist['2'].write_attribute('Sequence', Sequence_new)
        except:
            print('error  ' + str(self.paginadeci2_campo_Sequence_W.text()))

    def applica3sequenza(self):
        try:
            frequenza1050 = devicelist['frequenza'].BunchNumberFrequency
        except:
            frequenza1050 = -1
        try:
            tmp = str(self.paginadeci3_campo_Sequence_W.text()).replace('[', '').replace(']','')
            if self.paginadeci3_campo_modeR.text() == 'Status':
                if tmp.count('0') > 4:
                    self.msgBox = QMessageBox()
                    self.msgBox.setIcon(QMessageBox.Question)
                    self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
                    self.msgBox.setText("Decimation is too strong, if the frequency of the laser is below " + str(int(frequenza1050/5)) + "Hz thermal effects might degradate beam quality. Are you sure you want to proceed?")
                    risp = self.msgBox.exec_()
                    if risp == 1024:
                        Sequence_new = [int(aa) for aa in tmp.split(',')]
                        devicelist['3'].write_attribute('Sequence', Sequence_new)
                    else:
                        return
                else:
                    Sequence_new = [int(aa) for aa in tmp.split(',')]
                    devicelist['3'].write_attribute('Sequence', Sequence_new)
            else:
                Sequence_new = [int(aa) for aa in tmp.split(',')]
                devicelist['3'].write_attribute('Sequence', Sequence_new)
        except:
            print('error  ' + str(self.paginadeci3_campo_Sequence_W.text()))

    def applica4sequenza(self):
        try:
            frequenza1050 = devicelist['frequenza'].BunchNumberFrequency
        except:
            frequenza1050 = -1
        try:
            tmp = str(self.paginadeci4_campo_Sequence_W.text()).replace('[', '').replace(']','')
            if self.paginadeci4_campo_modeR.text() == 'Status':
                if tmp.count('0') > 4:
                    self.msgBox = QMessageBox()
                    self.msgBox.setIcon(QMessageBox.Question)
                    self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
                    self.msgBox.setText("Decimation is too strong, if the frequency of the laser is below " + str(int(frequenza1050/5)) + "Hz thermal effects might degradate beam quality. Are you sure you want to proceed?")
                    risp = self.msgBox.exec_()
                    if risp == 1024:
                        Sequence_new = [int(aa) for aa in tmp.split(',')]
                        devicelist['4'].write_attribute('Sequence', Sequence_new)
                    else:
                        return
                else:
                    Sequence_new = [int(aa) for aa in tmp.split(',')]
                    devicelist['4'].write_attribute('Sequence', Sequence_new)
            else:
                Sequence_new = [int(aa) for aa in tmp.split(',')]
                devicelist['4'].write_attribute('Sequence', Sequence_new)
        except:
            print('error  ' + str(self.paginadeci4_campo_Sequence_W.text()))

    def applica5sequenza(self):
        try:
            frequenza1050 = devicelist['frequenza'].BunchNumberFrequency
        except:
            frequenza1050 = -1
        try:
            tmp = str(self.paginadeci5_campo_Sequence_W.text()).replace('[', '').replace(']','')
            if self.paginadeci5_campo_modeR.text() == 'Status':
                if tmp.count('0') > 4:
                    self.msgBox = QMessageBox()
                    self.msgBox.setIcon(QMessageBox.Question)
                    self.msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
                    self.msgBox.setText("Decimation is too strong, if the frequency of the laser is below " + str(int(frequenza1050/5)) + "Hz thermal effects might degradate beam quality. Are you sure you want to proceed?")
                    risp = self.msgBox.exec_()
                    if risp == 1024:
                        Sequence_new = [int(aa) for aa in tmp.split(',')]
                        devicelist['5'].write_attribute('Sequence', Sequence_new)
                    else:
                        return
                else:
                    Sequence_new = [int(aa) for aa in tmp.split(',')]
                    devicelist['5'].write_attribute('Sequence', Sequence_new)
            else:
                Sequence_new = [int(aa) for aa in tmp.split(',')]
                devicelist['5'].write_attribute('Sequence', Sequence_new)
        except:
            print('error  ' + str(self.paginadeci5_campo_Sequence_W.text()))

    def applica1bnstart(self):
        BunchNumberStart_new = int(str(self.paginadeci1_campo_BunchNumberStart_W.text()))
        try:
            devicelist['1'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        except:
            print('error  ' + str(self.paginadeci1_campo_BunchNumberStart_W.text()))

    def applica2bnstart(self):
        BunchNumberStart_new = int(str(self.paginadeci2_campo_BunchNumberStart_W.text()))
        try:
            devicelist['2'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        except:
            print('error  ' + str(self.paginadeci2_campo_BunchNumberStart_W.text()))

    def applica3bnstart(self):
        BunchNumberStart_new = int(str(self.paginadeci3_campo_BunchNumberStart_W.text()))
        try:
            devicelist['3'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        except:
            print('error  ' + str(self.paginadeci3_campo_BunchNumberStart_W.text()))

    def applica4bnstart(self):
        BunchNumberStart_new = int(str(self.paginadeci4_campo_BunchNumberStart_W.text()))
        try:
            devicelist['4'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        except:
            print('error  ' + str(self.paginadeci4_campo_BunchNumberStart_W.text()))

    def applica5bnstart(self):
        BunchNumberStart_new = int(str(self.paginadeci5_campo_BunchNumberStart_W.text()))
        try:
            devicelist['5'].write_attribute('BunchNumberStart', BunchNumberStart_new)
        except:
            print('error  ' + str(self.paginadeci5_campo_BunchNumberStart_W.text()))

    def applicaInfiniteCycle(self):
        tmp = self.sender()
        if tmp.text() == 'On':
            devicelist[tmp.chiave].write_attribute('InfiniteCycle', True)
        elif tmp.text() == 'Off':
            devicelist[tmp.chiave].write_attribute('InfiniteCycle', False)

    def applica1MaxNumCycles(self):
        MaxNumCycles_new = int(str(self.paginadeci1_campo_MaxNumCycles_W.text()))
        try:
            devicelist['1'].write_attribute('MaxNumCycles', MaxNumCycles_new)
        except:
            print('error  ' + str(self.paginadeci1_campo_MaxNumCycles_W.text()))

    def applica2MaxNumCycles(self):
        MaxNumCycles_new = int(str(self.paginadeci2_campo_MaxNumCycles_W.text()))
        try:
            devicelist['2'].write_attribute('MaxNumCycles', MaxNumCycles_new)
        except:
            print('error  ' + str(self.paginadeci2_campo_MaxNumCycles_W.text()))

    def applica3MaxNumCycles(self):
        MaxNumCycles_new = int(str(self.paginadeci3_campo_MaxNumCycles_W.text()))
        try:
            devicelist['3'].write_attribute('MaxNumCycles', MaxNumCycles_new)
        except:
            print('error  ' + str(self.paginadeci3_campo_MaxNumCycles_W.text()))

    def applica4MaxNumCycles(self):
        MaxNumCycles_new = int(str(self.paginadeci4_campo_MaxNumCycles_W.text()))
        try:
            devicelist['4'].write_attribute('MaxNumCycles', MaxNumCycles_new)
        except:
            print('error  ' + str(self.paginadeci4_campo_MaxNumCycles_W.text()))

    def applica5MaxNumCycles(self):
        MaxNumCycles_new = int(str(self.paginadeci5_campo_MaxNumCycles_W.text()))
        try:
            devicelist['5'].write_attribute('MaxNumCycles', MaxNumCycles_new)
        except:
            print('error  ' + str(self.paginadeci5_campo_MaxNumCycles_W.text()))

    def applica1DelayOffset(self):
        DelayOffset_new = int(str(self.paginadeci1_campo_DelayOffset_R.text()))
        try:
            devicelist['1'].write_attribute('DelayOffset', DelayOffset_new)
        except:
            print('error  ' + str(self.paginadeci1_campo_DelayOffset_R.text()))

    def applica2DelayOffset(self):
        DelayOffset_new = int(str(self.paginadeci2_campo_DelayOffset_R.text()))
        try:
            devicelist['2'].write_attribute('DelayOffset', DelayOffset_new)
        except:
            print('error  ' + str(self.paginadeci2_campo_DelayOffset_R.text()))

    def applica3DelayOffset(self):
        DelayOffset_new = int(str(self.paginadeci3_campo_DelayOffset_R.text()))
        try:
            devicelist['3'].write_attribute('DelayOffset', DelayOffset_new)
        except:
            print('error  ' + str(self.paginadeci3_campo_DelayOffset_R.text()))

    def applica4DelayOffset(self):
        DelayOffset_new = int(str(self.paginadeci4_campo_DelayOffset_R.text()))
        try:
            devicelist['4'].write_attribute('DelayOffset', DelayOffset_new)
        except:
            print('error  ' + str(self.paginadeci4_campo_DelayOffset_R.text()))

    def applica5DelayOffset(self):
        DelayOffset_new = int(str(self.paginadeci4_campo_DelayOffset_R.text()))
        try:
            devicelist['5'].write_attribute('DelayOffset', DelayOffset_new)
        except:
            print('error  ' + str(self.paginadeci4_campo_DelayOffset_R.text()))

    def applicaPolarityMode(self):
        tmp = self.sender()
        if tmp.text() == 'On':
            devicelist[tmp.chiave].write_attribute('PolarityMode', True)
        elif tmp.text() == 'Off':
            devicelist[tmp.chiave].write_attribute('PolarityMode', False)

    def applicaReverseMode(self):
        tmp = self.sender()
        if tmp.text() == 'On':
            devicelist[tmp.chiave].write_attribute('ReverseMode', True)
        elif tmp.text() == 'Off':
            devicelist[tmp.chiave].write_attribute('ReverseMode', False)


class LineEditRO(QLineEdit):
    def __init__(self):
        super(LineEditRO, self).__init__()
        self.setReadOnly(1)
        self.setStyleSheet("background-color: rgb(200, 200, 200)")


app = QApplication([])
main = MainWindow()
app.exec_()